<?php
//万能写文件函数
function fpc($PATH,$String)
{
	if(empty($String)) return false; //无字符时不写入
	/* 调用递归创建目录  */
	creatdir(dirname($PATH));
	/* 以写入方式打开文件句柄,开启 flock  */
	$fopen = fopen($PATH,'w');
	flock($fopen, LOCK_EX + LOCK_NB);
	$fwrite = fwrite($fopen,$String);
	/* 失败重新尝试写入  */
	if (!$fwrite) $fwrite = fwrite($fopen,$String);
	flock($fopen, LOCK_UN + LOCK_NB);
	fclose($fopen);
	return $fwrite;
}
//建立目录
function creatdir($Dir)
{
	if (is_dir($Dir))
		return true;
	if (@ mkdir($Dir,0777))
		return true;
	if (!creatdir(dirname($Dir)))
		 return false;
	return mkdir($Dir,0777);
}
//解释模板
function p($tplfile){
	global $xingTemplate_set,$title,$kw,$des;
	if(empty($kw)) $kw=$title;
	if(empty($des)) $des=$title;
	//-----------------------------
	$tl = new xingTemplate($xingTemplate_set);
	$tl->display($tplfile);
}
//生成页面
function html($tplfile,$path){
	global $xingTemplate_set,$title,$kw,$des;
	if(empty($kw)) $kw=$title;
	if(empty($des)) $des=$title;
	//-----------------------------
	$path=WEBROOT."/".$path;
	$tl = new xingTemplate($xingTemplate_set);
	$data = $tl->fetch($tplfile);
	fpc($path,$data);
}
//复制文件
function mycopy($path1,$path2) {
	copy(WEBROOT."/".$path1,WEBROOT."/".$path2);
}
//建立缓存
function cache($path,$arr)
{
	fpc(WEBDATA.$path,serialize($arr));
}
//读取缓存
function loadcache($path)
{
	return unserialize(file_get_contents(WEBDATA.$path));
}
//建立文本缓存
function cachetxt($path,$txt) {
	fpc(WEBDATA.$path,$txt);
}
//读取文本缓存
function loadtxt($path)
{
	return file_get_contents(WEBDATA.$path);
}
//显示载入页面
function loadhtml($url){
	echo file_get_contents($url);
	exit();
}
//判断缓存是否过期，默认3小时
function iscache($url,$hh=3) {
	if(file_exists($url)) {
		$ftime=filemtime($url)+$hh*3600;
		if ($ftime>time()) {
			return true;
		}
	}
	return false;
}
?>